
const unsigned char ReportDesc[] = {
	0x05, 0x01,				// Usage Page (Generic Desktop)
	0x09, 0x06,				// Usage (keyboard)
	0xA1, 0x01,				// Collection (Application)
       
	0x05, 0x07,				// 	Usage Page (key codes)
	0x19, 0xE0,				// 	Usage minimum (0xE0)
	0x29, 0xE7,				// 	Usage maximum (0xE7)
	0x15, 0x00,				// 	Logical minimum (0x00)
	0x25, 0x01,				// 	Logical maximum (0x01)
	0x75, 0x01,				// 	Report size (1)
	0x95, 0x08,				// 	Report count(8)
	0x81, 0x02,				// 	Input (Data,Variable,Absolute)

	0x95, 0x06,				// 	Report Count (6)
	0x75, 0x08,				// 	Report size (8)
	0x15, 0x00,				// 	Logical minimum (0)
	0x25, 0x65,				// 	Logical maximum (101)
	0x05, 0x07,				// 	Usage page (Keycodes)
	0x19, 0x00,				// 	Usage minimum (0x00)
	0x29, 0x65,				// 	Usage maximum (101)
	0x81, 0x00,				// 	Input (Data,Array)
	0xC0					// End Collection
};

const unsigned char ConfigDesc[] = {

	// config descriptor

	0x09,					// bLength
	0x02,					// bDescriptorType
	0x22,					// wTotalLength (LSB)	config+interface+hid+endpoints
	0x00,					// wTotalLength (MSB)
	0x01,					// bNumInterfaces
	0x01,					// bConfigurationValue
	0x00,					// iConfiguration
	0x80,					// bmAttributes
	0x32,					// bMaxPower

	// interface descriptor

	0x09,					// bLength
	0x04,					// bDescriptorType
	0x00,					// bInterfaceNumber
	0x00,					// bAlternateSetting
	0x01,					// bNumEndpoints
	0x03,					// bInterfaceClass
	0x01,					// bInterfaceSubClass	
	0x01,					// bInterfaceProtocol	
	0x00,					// iInterface

	// HID descriptor

	0x09,					// bLength
	0x21,					// bDescriptorType
	0x10,					// bcdHID (LSB)
	0x01,					// bcdHID (MSB)
	0x00,					// bCountryCode
	0x01,					// bNumDescriptors
	0x22,					// bDescriptorType
	0x27,					// wDescriptorLength (LSB)
	0x00,					// wDescriptorLength (MSB)

	// endpoint descriptor 1

	0x07,					// bLength
	0x05,					// bDescriptorType
	0x81,					// bEndpointAddress
	0x03,					// bmAttributes
	0x40,0x00,				// wMaxPacketSize 
	0x0A,					// bInterval (milliseconds)
};

const unsigned char DeviceDesc[] = { //https://github.com/mikef5410/lpcopen/blob/master/lpcopen/applications/LPCUSBlib/lpcusblib_GenericHIDDevice/Descriptors.c
	// device descriptor

	0x12,					// bLength
	0x01,					// btype
	0x00,0x02,				// bcdUSB
	0x00,					// bDeviceClass
	0x00,					// bDeviceSubClass
	0x00,					// bDeviceprotocol
	0x40,					// bMaxPacketSize0
	0xC0,0x16,				// idVendor
	0x9A,0x06,				// idProduct
	0x00,0x01,				// bcdDevice
	0x01,                                   // iManufacturer
	0x02,					// iProduct
	0x03,					// iSerialNumber
	0x01					// bNumConfigurations
}; 

const unsigned char StringDescriptor[] = {
        0x04,                                   // bLength
        0x03,                                   // bDescriptorType
        0x09,0x04,                              // LangID codes

	// string descriptor 1

	0x08,					// bLength
	0x03,					// bDescriptorType
	'A',0,'B',0,'C',0,			// bString

	// string descriptor 2

	0x08,					// bLength
	0x03,					// bDescriptorType
	'1',0,'2',0,'3',0,			// bString

	// string descriptor 3

	0x08,					// bLength
	0x03,					// bDescriptorType
	'X',0,'Y',0,'Z',0			// bString
};


