// lpc11U24.h

// Define some bitmasks

#define BIT0 (1 << 0)
#define BIT1 (1 << 1)
#define BIT2 (1 << 2)
#define BIT3 (1 << 3)
#define BIT4 (1 << 4)
#define BIT5 (1 << 5)
#define BIT6 (1 << 6)
#define BIT7 (1 << 7)
#define BIT8 (1 << 8)
#define BIT9 (1 << 9)
#define BIT10 (1 << 10)
#define BIT11 (1 << 11)
#define BIT12 (1 << 12)
#define BIT13 (1 << 13)
#define BIT14 (1 << 14)
#define BIT15 (1 << 15)
#define BIT16 (1 << 16)
#define BIT17 (1 << 17)
#define BIT18 (1 << 18)
#define BIT19 (1 << 19)
#define BIT20 (1 << 20)
#define BIT21 (1 << 21)
#define BIT22 (1 << 22)
#define BIT23 (1 << 23)
#define BIT24 (1 << 24)
#define BIT25 (1 << 25)
#define BIT26 (1 << 26)
#define BIT27 (1 << 27)
#define BIT28 (1 << 28)
#define BIT29 (1 << 29)
#define BIT30 (1 << 30)
#define BIT31 (1 << 31)

// Macros to reduce typing later on

#define  REGISTER_32(ADDRESS) (*((volatile unsigned int *)(ADDRESS)))
#define  REGISTER_16(ADDRESS) (*((volatile unsigned int *)(ADDRESS)))

// Macros to enable/disable global interrupts

#define enable_interrupts() asm(" cpsie i ")
#define disable_interrupts() asm(" cpsid i ")

// APB Peripherals

#define I2C_BASE 		0x40000000
#define WDT_BASE 		0x40004000
#define UART_BASE 		0x40008000
#define TMR16B0_BASE		0x4000c000
#define TMR16B1_BASE		0x40010000
#define TMR32B0_BASE		0x40014000
#define TMR32B1_BASE		0x40018000
#define ADC_BASE		0x4001c000
#define PMU_BASE		0x40038000
#define FLASH_CTRL_BASE		0x4003c000
#define SSP0_BASE		0x40040000
#define IOCONFIG_BASE 		0x40044000
#define SYSCON_BASE 		0x40048000
#define C_CAN_BASE		0x40050000
#define SSP1_BASE		0x40058000
#define GPIO_BASE 		0x50000000

// I2C

#define I2C0CONSET		REGISTER_32(I2C_BASE + 0x000)
#define I2C0STAT		REGISTER_32(I2C_BASE + 0x004)
#define I2C0DAT			REGISTER_32(I2C_BASE + 0x008)
#define I2C0ADR0		REGISTER_32(I2C_BASE + 0x00c)
#define I2C0SCLH		REGISTER_32(I2C_BASE + 0x010)
#define I2C0SCLL		REGISTER_32(I2C_BASE + 0x014)
#define I2C0CONCLR		REGISTER_32(I2C_BASE + 0x018)
#define I2C0COMMCTRL		REGISTER_32(I2C_BASE + 0x01c)
#define I2C0ADR1		REGISTER_32(I2C_BASE + 0x020)
#define I2C0ADR2		REGISTER_32(I2C_BASE + 0x024)
#define I2C0ADR3		REGISTER_32(I2C_BASE + 0x028)
#define I2C0DATA_BUFFER		REGISTER_32(I2C_BASE + 0x02c)
#define I2C0MASK0		REGISTER_32(I2C_BASE + 0x030)
#define I2C0MASK1		REGISTER_32(I2C_BASE + 0x034)
#define I2C0MASK2		REGISTER_32(I2C_BASE + 0x038)
#define I2C0MASK3		REGISTER_32(I2C_BASE + 0x03c)

// WDT

#define WDMOD			REGISTER_32(WDT_BASE + 0x000)
#define WDTC			REGISTER_32(WDT_BASE + 0x004)
#define WDFEED			REGISTER_32(WDT_BASE + 0x008)
#define WDTV			REGISTER_32(WDT_BASE + 0x00c)
#define WDWARNINT		REGISTER_32(WDT_BASE + 0x014)
#define WDWINDOW		REGISTER_32(WDT_BASE + 0x018)

// UART
// registers appear to share addresses here.  Depending 
// on the state of DLAB different registers are active.
// Also some registers are read-only, some write-only

#define U0RBR			REGISTER_32(UART_BASE + 0x000) 
#define U0THR			REGISTER_32(UART_BASE + 0x000)
#define U0DLL			REGISTER_32(UART_BASE + 0x000)
#define U0DLM			REGISTER_32(UART_BASE + 0x004)
#define U0IER			REGISTER_32(UART_BASE + 0x004)
#define U0IIR			REGISTER_32(UART_BASE + 0x008)
#define U0FCR			REGISTER_32(UART_BASE + 0x008)
#define U0LCR			REGISTER_32(UART_BASE + 0x00c)
#define U0MCR			REGISTER_32(UART_BASE + 0x010)
#define U0LSR			REGISTER_32(UART_BASE + 0x014)
#define U0MSR			REGISTER_32(UART_BASE + 0x018)
#define U0SCR			REGISTER_32(UART_BASE + 0x01c)
#define U0ACR			REGISTER_32(UART_BASE + 0x020)
#define U0FDR			REGISTER_32(UART_BASE + 0x028)
#define U0TER			REGISTER_32(UART_BASE + 0x030)
#define U0RS485CTRL		REGISTER_32(UART_BASE + 0x04c)
#define U0RS485ADRMATCH		REGISTER_32(UART_BASE + 0x050)
#define U0RS485DLY		REGISTER_32(UART_BASE + 0x054)

// TMR16B0

#define TMR16B0IR		REGISTER_32(TMR16B0_BASE + 0x000)
#define TMR16B0TCR		REGISTER_32(TMR16B0_BASE + 0x004)
#define TMR16B0TC		REGISTER_32(TMR16B0_BASE + 0x008)
#define TMR16B0PR		REGISTER_32(TMR16B0_BASE + 0x00c)
#define TMR16B0PC		REGISTER_32(TMR16B0_BASE + 0x010)
#define TMR16B0MCR		REGISTER_32(TMR16B0_BASE + 0x014)
#define TMR16B0MR0		REGISTER_32(TMR16B0_BASE + 0x018)
#define TMR16B0MR1		REGISTER_32(TMR16B0_BASE + 0x01c)
#define TMR16B0MR2		REGISTER_32(TMR16B0_BASE + 0x020)
#define TMR16B0MR3		REGISTER_32(TMR16B0_BASE + 0x024)
#define TMR16B0CCR		REGISTER_32(TMR16B0_BASE + 0x028)
#define TMR16B0CR0		REGISTER_32(TMR16B0_BASE + 0x02c)
#define TMR16B0CR1		REGISTER_32(TMR16B0_BASE + 0x030)
#define TMR16B0EMR		REGISTER_32(TMR16B0_BASE + 0x03c)
#define TMR16B0CTCR		REGISTER_32(TMR16B0_BASE + 0x070)
#define TMR16B0PWMC		REGISTER_32(TMR16B0_BASE + 0x074)

// TMR16B1

#define TMR16B1IR		REGISTER_32(TMR16B1_BASE + 0x000)
#define TMR16B1TCR		REGISTER_32(TMR16B1_BASE + 0x004)
#define TMR16B1TC		REGISTER_32(TMR16B1_BASE + 0x008)
#define TMR16B1PR		REGISTER_32(TMR16B1_BASE + 0x00c)
#define TMR16B1PC		REGISTER_32(TMR16B1_BASE + 0x010)
#define TMR16B1MCR		REGISTER_32(TMR16B1_BASE + 0x014)
#define TMR16B1MR0		REGISTER_32(TMR16B1_BASE + 0x018)
#define TMR16B1MR1		REGISTER_32(TMR16B1_BASE + 0x01c)
#define TMR16B1MR2		REGISTER_32(TMR16B1_BASE + 0x020)
#define TMR16B1MR3		REGISTER_32(TMR16B1_BASE + 0x024)
#define TMR16B1CCR		REGISTER_32(TMR16B1_BASE + 0x028)
#define TMR16B1CR0		REGISTER_32(TMR16B1_BASE + 0x02c)
#define TMR16B1CR1		REGISTER_32(TMR16B1_BASE + 0x030)
#define TMR16B1EMR		REGISTER_32(TMR16B1_BASE + 0x03c)
#define TMR16B1CTCR		REGISTER_32(TMR16B1_BASE + 0x070)
#define TMR16B1PWMC		REGISTER_32(TMR16B1_BASE + 0x074)

// TMR32B0

#define TMR32B0IR		REGISTER_32(TMR32B0_BASE + 0x000)
#define TMR32B0TCR		REGISTER_32(TMR32B0_BASE + 0x004)
#define TMR32B0TC		REGISTER_32(TMR32B0_BASE + 0x008)
#define TMR32B0PR		REGISTER_32(TMR32B0_BASE + 0x00c)
#define TMR32B0PC		REGISTER_32(TMR32B0_BASE + 0x010)
#define TMR32B0MCR		REGISTER_32(TMR32B0_BASE + 0x014)
#define TMR32B0MR0		REGISTER_32(TMR32B0_BASE + 0x018)
#define TMR32B0MR1		REGISTER_32(TMR32B0_BASE + 0x01c)
#define TMR32B0MR2		REGISTER_32(TMR32B0_BASE + 0x020)
#define TMR32B0MR3		REGISTER_32(TMR32B0_BASE + 0x024)
#define TMR32B0CCR		REGISTER_32(TMR32B0_BASE + 0x028)
#define TMR32B0CR0		REGISTER_32(TMR32B0_BASE + 0x02c)
#define TMR32B0CR1		REGISTER_32(TMR32B0_BASE + 0x030)
#define TMR32B0EMR		REGISTER_32(TMR32B0_BASE + 0x03c)
#define TMR32B0CTCR		REGISTER_32(TMR32B0_BASE + 0x070)
#define TMR32B0PWMC		REGISTER_32(TMR32B0_BASE + 0x074)

// TMR32B1

#define TMR32B1IR		REGISTER_32(TMR32B1_BASE + 0x000)
#define TMR32B1TCR		REGISTER_32(TMR32B1_BASE + 0x004)
#define TMR32B1TC		REGISTER_32(TMR32B1_BASE + 0x008)
#define TMR32B1PR		REGISTER_32(TMR32B1_BASE + 0x00c)
#define TMR32B1PC		REGISTER_32(TMR32B1_BASE + 0x010)
#define TMR32B1MCR		REGISTER_32(TMR32B1_BASE + 0x014)
#define TMR32B1MR0		REGISTER_32(TMR32B1_BASE + 0x018)
#define TMR32B1MR1		REGISTER_32(TMR32B1_BASE + 0x01c)
#define TMR32B1MR2		REGISTER_32(TMR32B1_BASE + 0x020)
#define TMR32B1MR3		REGISTER_32(TMR32B1_BASE + 0x024)
#define TMR32B1CCR		REGISTER_32(TMR32B1_BASE + 0x028)
#define TMR32B1CR0		REGISTER_32(TMR32B1_BASE + 0x02c)
#define TMR32B1CR1		REGISTER_32(TMR32B1_BASE + 0x030)
#define TMR32B1EMR		REGISTER_32(TMR32B1_BASE + 0x03c)
#define TMR32B1CTCR		REGISTER_32(TMR32B1_BASE + 0x070)
#define TMR32B1PWMC		REGISTER_32(TMR32B1_BASE + 0x074)

// ADC 

#define AD0CR			REGISTER_32(ADC_BASE + 0x000)
#define AD0GDR			REGISTER_32(ADC_BASE + 0x004)
#define AD0INTEN		REGISTER_32(ADC_BASE + 0x00c)
#define AD0DR0			REGISTER_32(ADC_BASE + 0x010)
#define AD0DR1			REGISTER_32(ADC_BASE + 0x014)
#define AD0DR2			REGISTER_32(ADC_BASE + 0x018)
#define AD0DR3			REGISTER_32(ADC_BASE + 0x01c)
#define AD0DR4			REGISTER_32(ADC_BASE + 0x020)
#define AD0DR5			REGISTER_32(ADC_BASE + 0x024)
#define AD0DR6			REGISTER_32(ADC_BASE + 0x028)
#define AD0DR7			REGISTER_32(ADC_BASE + 0x02c)
#define AD0STAT			REGISTER_32(ADC_BASE + 0x030)

// PMU

#define PCON			REGISTER_32(PMU_BASE + 0x000)
#define GPREG0			REGISTER_32(PMU_BASE + 0x004)
#define GPREG1			REGISTER_32(PMU_BASE + 0x008)
#define GPREG2			REGISTER_32(PMU_BASE + 0x00c)
#define GPREG3			REGISTER_32(PMU_BASE + 0x010)
#define GPREG4			REGISTER_32(PMU_BASE + 0x014)

// FLASH CONTROLLER

#define FLASHCFG		REGISTER_32(FLASH_CTRL_BASE + 0x010)
#define FMSSTART		REGISTER_32(FLASH_CTRL_BASE + 0x020)
#define FMSSTOP			REGISTER_32(FLASH_CTRL_BASE + 0x024)
#define FMSW0			REGISTER_32(FLASH_CTRL_BASE + 0x02c)
#define FMSW1			REGISTER_32(FLASH_CTRL_BASE + 0x030)
#define FMSW2			REGISTER_32(FLASH_CTRL_BASE + 0x034)
#define FMSW3			REGISTER_32(FLASH_CTRL_BASE + 0x038)
#define FMSTAT			REGISTER_32(FLASH_CTRL_BASE + 0xfe0)
#define FMSTATCLR		REGISTER_32(FLASH_CTRL_BASE + 0xfe8)

// IOCONFIG

#define PIO0_0			REGISTER_32(IOCONFIG_BASE + 0x000)
#define PIO0_1			REGISTER_32(IOCONFIG_BASE + 0x004)
#define PIO0_2			REGISTER_32(IOCONFIG_BASE + 0x008)
#define PIO0_3			REGISTER_32(IOCONFIG_BASE + 0x00C)
#define PIO0_4			REGISTER_32(IOCONFIG_BASE + 0x010)
#define PIO0_5			REGISTER_32(IOCONFIG_BASE + 0x014)
#define PIO0_6			REGISTER_32(IOCONFIG_BASE + 0x018)
#define PIO0_7			REGISTER_32(IOCONFIG_BASE + 0x01C)
#define PIO0_8			REGISTER_32(IOCONFIG_BASE + 0x020)
#define PIO0_9			REGISTER_32(IOCONFIG_BASE + 0x024)
#define PIO0_10			REGISTER_32(IOCONFIG_BASE + 0x028)
#define PIO0_11			REGISTER_32(IOCONFIG_BASE + 0x02C)
#define PIO0_12			REGISTER_32(IOCONFIG_BASE + 0x030)
#define PIO0_13			REGISTER_32(IOCONFIG_BASE + 0x034)
#define PIO0_14			REGISTER_32(IOCONFIG_BASE + 0x038)
#define PIO0_15			REGISTER_32(IOCONFIG_BASE + 0x03C)
#define PIO0_16			REGISTER_32(IOCONFIG_BASE + 0x040)
#define PIO0_17			REGISTER_32(IOCONFIG_BASE + 0x044)
#define PIO0_18			REGISTER_32(IOCONFIG_BASE + 0x048)
#define PIO0_19			REGISTER_32(IOCONFIG_BASE + 0x04C)
#define PIO0_20			REGISTER_32(IOCONFIG_BASE + 0x050)
#define PIO0_21			REGISTER_32(IOCONFIG_BASE + 0x054)
#define PIO0_22			REGISTER_32(IOCONFIG_BASE + 0x058)
#define PIO0_23			REGISTER_32(IOCONFIG_BASE + 0x05C)
#define PIO1_0			REGISTER_32(IOCONFIG_BASE + 0x060)
#define PIO1_1			REGISTER_32(IOCONFIG_BASE + 0x064)
#define PIO1_2			REGISTER_32(IOCONFIG_BASE + 0x068)
#define PIO1_3			REGISTER_32(IOCONFIG_BASE + 0x06C)
#define PIO1_4			REGISTER_32(IOCONFIG_BASE + 0x070)
#define PIO1_5			REGISTER_32(IOCONFIG_BASE + 0x074)
#define PIO1_6			REGISTER_32(IOCONFIG_BASE + 0x078)
#define PIO1_7			REGISTER_32(IOCONFIG_BASE + 0x07C)
#define PIO1_8			REGISTER_32(IOCONFIG_BASE + 0x080)
#define PIO1_9			REGISTER_32(IOCONFIG_BASE + 0x084)
#define PIO1_10			REGISTER_32(IOCONFIG_BASE + 0x088)
#define PIO1_11			REGISTER_32(IOCONFIG_BASE + 0x08C)
#define PIO1_12			REGISTER_32(IOCONFIG_BASE + 0x090)
#define PIO1_13			REGISTER_32(IOCONFIG_BASE + 0x094)
#define PIO1_14			REGISTER_32(IOCONFIG_BASE + 0x098)
#define PIO1_15			REGISTER_32(IOCONFIG_BASE + 0x09C)
#define PIO1_16			REGISTER_32(IOCONFIG_BASE + 0x0A0)
#define PIO1_17			REGISTER_32(IOCONFIG_BASE + 0x0A4)
#define PIO1_18			REGISTER_32(IOCONFIG_BASE + 0x0A8)
#define PIO1_19			REGISTER_32(IOCONFIG_BASE + 0x0AC)
#define PIO1_20			REGISTER_32(IOCONFIG_BASE + 0x0B0)
#define PIO1_21			REGISTER_32(IOCONFIG_BASE + 0x0B4)
#define PIO1_22			REGISTER_32(IOCONFIG_BASE + 0x0B8)
#define PIO1_23			REGISTER_32(IOCONFIG_BASE + 0x0BC)
#define PIO1_24			REGISTER_32(IOCONFIG_BASE + 0x0C0)
#define PIO1_25			REGISTER_32(IOCONFIG_BASE + 0x0C4)
#define PIO1_26			REGISTER_32(IOCONFIG_BASE + 0x0C8)
#define PIO1_27			REGISTER_32(IOCONFIG_BASE + 0x0CC)
#define PIO1_28			REGISTER_32(IOCONFIG_BASE + 0x0D0)
#define PIO1_29			REGISTER_32(IOCONFIG_BASE + 0x0D4)
#define PIO1_30			REGISTER_32(IOCONFIG_BASE + 0x0D8)
#define PIO1_31			REGISTER_32(IOCONFIG_BASE + 0x0DC)

// GPIO

#define GPIO0_PBYTE0		REGISTER_32(GPIO_BASE + 0x0000)
#define GPIO0_PBYTE1		REGISTER_32(GPIO_BASE + 0x0001)
#define GPIO0_PBYTE2		REGISTER_32(GPIO_BASE + 0x0002)
#define GPIO0_PBYTE3		REGISTER_32(GPIO_BASE + 0x0003)
#define GPIO0_PBYTE4		REGISTER_32(GPIO_BASE + 0x0004)
#define GPIO0_PBYTE5		REGISTER_32(GPIO_BASE + 0x0005)
#define GPIO0_PBYTE6		REGISTER_32(GPIO_BASE + 0x0006)
#define GPIO0_PBYTE7		REGISTER_32(GPIO_BASE + 0x0007)
#define GPIO0_PBYTE8		REGISTER_32(GPIO_BASE + 0x0008)
#define GPIO0_PBYTE9		REGISTER_32(GPIO_BASE + 0x0009)
#define GPIO0_PBYTE10		REGISTER_32(GPIO_BASE + 0x000A)
#define GPIO0_PBYTE11		REGISTER_32(GPIO_BASE + 0x000B)
#define GPIO0_PBYTE12		REGISTER_32(GPIO_BASE + 0x000C)
#define GPIO0_PBYTE13		REGISTER_32(GPIO_BASE + 0x000D)
#define GPIO0_PBYTE14		REGISTER_32(GPIO_BASE + 0x000E)
#define GPIO0_PBYTE15		REGISTER_32(GPIO_BASE + 0x000F)
#define GPIO0_PBYTE16		REGISTER_32(GPIO_BASE + 0x0010)
#define GPIO0_PBYTE17		REGISTER_32(GPIO_BASE + 0x0011)
#define GPIO0_PBYTE18		REGISTER_32(GPIO_BASE + 0x0012)
#define GPIO0_PBYTE19		REGISTER_32(GPIO_BASE + 0x0013)
#define GPIO0_PBYTE20		REGISTER_32(GPIO_BASE + 0x0014)
#define GPIO0_PBYTE21		REGISTER_32(GPIO_BASE + 0x0015)
#define GPIO0_PBYTE22		REGISTER_32(GPIO_BASE + 0x0016)
#define GPIO0_PBYTE23		REGISTER_32(GPIO_BASE + 0x0017)
#define GPIO1_PBYTE0		REGISTER_32(GPIO_BASE + 0x0020)
#define GPIO1_PBYTE1		REGISTER_32(GPIO_BASE + 0x0021)
#define GPIO1_PBYTE2		REGISTER_32(GPIO_BASE + 0x0022)
#define GPIO1_PBYTE3		REGISTER_32(GPIO_BASE + 0x0023)
#define GPIO1_PBYTE4		REGISTER_32(GPIO_BASE + 0x0024)
#define GPIO1_PBYTE5		REGISTER_32(GPIO_BASE + 0x0025)
#define GPIO1_PBYTE6		REGISTER_32(GPIO_BASE + 0x0026)
#define GPIO1_PBYTE7		REGISTER_32(GPIO_BASE + 0x0027)
#define GPIO1_PBYTE8		REGISTER_32(GPIO_BASE + 0x0028)
#define GPIO1_PBYTE9		REGISTER_32(GPIO_BASE + 0x0029)
#define GPIO1_PBYTE10		REGISTER_32(GPIO_BASE + 0x002A)
#define GPIO1_PBYTE11		REGISTER_32(GPIO_BASE + 0x002B)
#define GPIO1_PBYTE12		REGISTER_32(GPIO_BASE + 0x002C)
#define GPIO1_PBYTE13		REGISTER_32(GPIO_BASE + 0x002D)
#define GPIO1_PBYTE14		REGISTER_32(GPIO_BASE + 0x002E)
#define GPIO1_PBYTE15		REGISTER_32(GPIO_BASE + 0x002F)
#define GPIO1_PBYTE16		REGISTER_32(GPIO_BASE + 0x0030)
#define GPIO1_PBYTE17		REGISTER_32(GPIO_BASE + 0x0031)
#define GPIO1_PBYTE18		REGISTER_32(GPIO_BASE + 0x0032)
#define GPIO1_PBYTE19		REGISTER_32(GPIO_BASE + 0x0033)
#define GPIO1_PBYTE20		REGISTER_32(GPIO_BASE + 0x0034)
#define GPIO1_PBYTE21		REGISTER_32(GPIO_BASE + 0x0035)
#define GPIO1_PBYTE22		REGISTER_32(GPIO_BASE + 0x0036)
#define GPIO1_PBYTE23		REGISTER_32(GPIO_BASE + 0x0037)
#define GPIO1_PBYTE24		REGISTER_32(GPIO_BASE + 0x0038)
#define GPIO1_PBYTE25		REGISTER_32(GPIO_BASE + 0x0039)
#define GPIO1_PBYTE26		REGISTER_32(GPIO_BASE + 0x003A)
#define GPIO1_PBYTE27		REGISTER_32(GPIO_BASE + 0x003B)
#define GPIO1_PBYTE28		REGISTER_32(GPIO_BASE + 0x003C)
#define GPIO1_PBYTE29		REGISTER_32(GPIO_BASE + 0x003D)
#define GPIO1_PBYTE30		REGISTER_32(GPIO_BASE + 0x003E)
#define GPIO1_PBYTE31		REGISTER_32(GPIO_BASE + 0x003F)

#define DIR0			REGISTER_32(GPIO_BASE + 0x2000)
#define DIR1			REGISTER_32(GPIO_BASE + 0x2004)
#define	PIN0			REGISTER_32(GPIO_BASE + 0x2100)
#define	PIN1			REGISTER_32(GPIO_BASE + 0x2104)

// SYSCON

#define SYSMEMREMAP		REGISTER_32(SYSCON_BASE + 0x000)
#define PRESETCTRL		REGISTER_32(SYSCON_BASE + 0x004)
#define SYSPLLCTRL		REGISTER_32(SYSCON_BASE + 0x008)
#define SYSPLLSTAT		REGISTER_32(SYSCON_BASE + 0x00c)
#define	USBPLLCTRL		REGISTER_32(SYSCON_BASE + 0x010)
#define	USBPLLSTAT		REGISTER_32(SYSCON_BASE + 0x014)
#define SYSOSCCTRL		REGISTER_32(SYSCON_BASE + 0x020)
#define WDTOSCCTRL		REGISTER_32(SYSCON_BASE + 0x024)
#define IRCCTL			REGISTER_32(SYSCON_BASE + 0x028)
#define SYSRSTSTAT		REGISTER_32(SYSCON_BASE + 0x030)
#define SYSPLLCLKSEL		REGISTER_32(SYSCON_BASE + 0x040)
#define SYSPLLCLKUEN		REGISTER_32(SYSCON_BASE + 0x044)
#define USBPLLCLKSEL		REGISTER_32(SYSCON_BASE + 0x048)
#define USBPLLCLKUEN		REGISTER_32(SYSCON_BASE + 0x04C)
#define MAINCLKSEL		REGISTER_32(SYSCON_BASE + 0x070)
#define MAINCLKUEN		REGISTER_32(SYSCON_BASE + 0x074)
#define SYSAHBCLKDIV		REGISTER_32(SYSCON_BASE + 0x078)
#define SYSAHBCLKCTRL		REGISTER_32(SYSCON_BASE + 0x080)
#define SSP0CLKDIV		REGISTER_32(SYSCON_BASE + 0x094)
#define UARTCLKDIV		REGISTER_32(SYSCON_BASE + 0x098)
#define SSP1CLKDIV		REGISTER_32(SYSCON_BASE + 0x09c)
#define USBCLKSEL		REGISTER_32(SYSCON_BASE + 0x0C0)
#define USBCLKDIV		REGISTER_32(SYSCON_BASE + 0x0C8)
#define WDTCLKSEL		REGISTER_32(SYSCON_BASE + 0x0D0)
#define WDTCLKUEN		REGISTER_32(SYSCON_BASE + 0x0D4)
#define WDTCLKDIV		REGISTER_32(SYSCON_BASE + 0x0D8)
#define CLKOUTCLKSEL		REGISTER_32(SYSCON_BASE + 0x0E0)
#define CLKOUTUEN		REGISTER_32(SYSCON_BASE + 0x0E4)
#define CLKOUTCLKDIV		REGISTER_32(SYSCON_BASE + 0x0E8)
#define PIOPORCAP0		REGISTER_32(SYSCON_BASE + 0x100)
#define PIOPORCAP1		REGISTER_32(SYSCON_BASE + 0x104)
#define BODCTRL			REGISTER_32(SYSCON_BASE + 0x150)
#define SYSTCKCAL		REGISTER_32(SYSCON_BASE + 0x154)
#define NMISRC			REGISTER_32(SYSCON_BASE + 0x174)
#define STARTAPRP0		REGISTER_32(SYSCON_BASE + 0x200)
#define STARTERP0		REGISTER_32(SYSCON_BASE + 0x204)
#define STARTRSRP0CLR		REGISTER_32(SYSCON_BASE + 0x208)
#define STARTSRP0		REGISTER_32(SYSCON_BASE + 0x20C)
#define PDSLEEPCFG		REGISTER_32(SYSCON_BASE + 0x230)
#define PDAWAKECFG		REGISTER_32(SYSCON_BASE + 0x234)
#define PDRUNCFG		REGISTER_32(SYSCON_BASE + 0x238)
#define DEVICE_ID		REGISTER_32(SYSCON_BASE + 0x3F4)

// CAN

#define CANCNTL			REGISTER_32(C_CAN_BASE + 0x000)
#define CANSTAT			REGISTER_32(C_CAN_BASE + 0x004)
#define CANEC			REGISTER_32(C_CAN_BASE + 0x008)
#define CANBT			REGISTER_32(C_CAN_BASE + 0x00c)
#define CANINT			REGISTER_32(C_CAN_BASE + 0x010)
#define CANTEST			REGISTER_32(C_CAN_BASE + 0x014)
#define CANBRPE			REGISTER_32(C_CAN_BASE + 0x018)
#define CANIF1_CMDREQ		REGISTER_32(C_CAN_BASE + 0x020)
#define CANIF1_CMDMSK_W		REGISTER_32(C_CAN_BASE + 0x024)
#define CANIF1_CMDMSK_R		REGISTER_32(C_CAN_BASE + 0x024)
#define CANIF1_MSK1		REGISTER_32(C_CAN_BASE + 0x028)
#define CANIF1_MSK2		REGISTER_32(C_CAN_BASE + 0x02c)
#define CANIF1_ARB1		REGISTER_32(C_CAN_BASE + 0x030)
#define CANIF1_ARB2		REGISTER_32(C_CAN_BASE + 0x034)
#define CANIF1_MCTRL		REGISTER_32(C_CAN_BASE + 0x038)
#define CANIF1_DA1		REGISTER_32(C_CAN_BASE + 0x03c)
#define CANIF1_DA2		REGISTER_32(C_CAN_BASE + 0x040)
#define CANIF1_DB1		REGISTER_32(C_CAN_BASE + 0x044)
#define CANIF1_DB2		REGISTER_32(C_CAN_BASE + 0x048)
#define CANIF2_CMDREQ		REGISTER_32(C_CAN_BASE + 0x080)
#define CANIF2_CMDMSK_W		REGISTER_32(C_CAN_BASE + 0x084)
#define CANIF2_CMDMSK_R		REGISTER_32(C_CAN_BASE + 0x084)
#define CANIF2_MSK1		REGISTER_32(C_CAN_BASE + 0x088)
#define CANIF2_MSK2		REGISTER_32(C_CAN_BASE + 0x08c)
#define CANIF2_ARB1		REGISTER_32(C_CAN_BASE + 0x090)
#define CANIF2_ARB2		REGISTER_32(C_CAN_BASE + 0x094)
#define CANIF2_MCTRL		REGISTER_32(C_CAN_BASE + 0x098)
#define CANIF2_DA1		REGISTER_32(C_CAN_BASE + 0x09c)
#define CANIF2_DA2		REGISTER_32(C_CAN_BASE + 0x0a0)
#define CANIF2_DB1		REGISTER_32(C_CAN_BASE + 0x0a4)
#define CANIF2_DB2		REGISTER_32(C_CAN_BASE + 0x0a8)
#define CANTXREQ1		REGISTER_32(C_CAN_BASE + 0x100)
#define CANTXREQ2		REGISTER_32(C_CAN_BASE + 0x104)
#define CANND1			REGISTER_32(C_CAN_BASE + 0x120)
#define CANND2			REGISTER_32(C_CAN_BASE + 0x124)
#define CANIR1			REGISTER_32(C_CAN_BASE + 0x140)
#define CANIR2			REGISTER_32(C_CAN_BASE + 0x144)
#define CANMSGV1		REGISTER_32(C_CAN_BASE + 0x160)
#define CANNSGV2		REGISTER_32(C_CAN_BASE + 0x164)
#define CANCLKDIV		REGISTER_32(C_CAN_BASE + 0x180)

// SSP0

#define SSP0CR0			REGISTER_32(SSP0_BASE + 0x000)
#define SSP0CR1			REGISTER_32(SSP0_BASE + 0x004)
#define SSP0DR			REGISTER_32(SSP0_BASE + 0x008)
#define SSP0SR			REGISTER_32(SSP0_BASE + 0x00c)
#define SSP0CPSR		REGISTER_32(SSP0_BASE + 0x010)
#define SSP0IMSC		REGISTER_32(SSP0_BASE + 0x014)
#define SSP0RIS			REGISTER_32(SSP0_BASE + 0x018)
#define SSP0MIS			REGISTER_32(SSP0_BASE + 0x01c)
#define SSP0ICR			REGISTER_32(SSP0_BASE + 0x020)

// SSP1

#define SSP1CR0			REGISTER_32(SSP1_BASE + 0x000)
#define SSP1CR1			REGISTER_32(SSP1_BASE + 0x004)
#define SSP1DR			REGISTER_32(SSP1_BASE + 0x008)
#define SSP1SR			REGISTER_32(SSP1_BASE + 0x00c)
#define SSP1CPSR		REGISTER_32(SSP1_BASE + 0x010)
#define SSP1IMSC		REGISTER_32(SSP1_BASE + 0x014)
#define SSP1RIS			REGISTER_32(SSP1_BASE + 0x018)
#define SSP1MIS			REGISTER_32(SSP1_BASE + 0x01c)
#define SSP1ICR			REGISTER_32(SSP1_BASE + 0x020)

// AHB Peripherals

#define GPIO0_BASE		0x50000000
#define GPIO1_BASE		0x50010000
#define GPIO2_BASE		0x50020000
#define GPIO3_BASE		0x50030000

// not dealing with mask registers here

#define GPIO0DATA		REGISTER_32(GPIO0_BASE + 0x3ffc)
#define GPIO0DIR		REGISTER_32(GPIO0_BASE + 0x8000)
#define GPIO0IS			REGISTER_32(GPIO0_BASE + 0x8004)
#define GPIO0IBE		REGISTER_32(GPIO0_BASE + 0x8008)
#define GPIO0IEV		REGISTER_32(GPIO0_BASE + 0x800c)
#define GPIO0IE			REGISTER_32(GPIO0_BASE + 0x8010)
#define GPIO0RIS		REGISTER_32(GPIO0_BASE + 0x8014)
#define GPIO0MIS		REGISTER_32(GPIO0_BASE + 0x8018)
#define GPIO0IC			REGISTER_32(GPIO0_BASE + 0x801c)

// not dealing with mask registers here

#define GPIO1DATA		REGISTER_32(GPIO1_BASE + 0x3ffc)
#define GPIO1DIR		REGISTER_32(GPIO1_BASE + 0x8000)
#define GPIO1IS			REGISTER_32(GPIO1_BASE + 0x8004)
#define GPIO1IBE		REGISTER_32(GPIO1_BASE + 0x8008)
#define GPIO1IEV		REGISTER_32(GPIO1_BASE + 0x800c)
#define GPIO1IE			REGISTER_32(GPIO1_BASE + 0x8010)
#define GPIO1RIS		REGISTER_32(GPIO1_BASE + 0x8014)
#define GPIO1MIS		REGISTER_32(GPIO1_BASE + 0x8018)
#define GPIO1IC			REGISTER_32(GPIO1_BASE + 0x801c)

// not dealing with mask registers here

#define GPIO2DATA		REGISTER_32(GPIO2_BASE + 0x3ffc)
#define GPIO2DIR		REGISTER_32(GPIO2_BASE + 0x8000)
#define GPIO2IS			REGISTER_32(GPIO2_BASE + 0x8004)
#define GPIO2IBE		REGISTER_32(GPIO2_BASE + 0x8008)
#define GPIO2IEV		REGISTER_32(GPIO2_BASE + 0x800c)
#define GPIO2IE			REGISTER_32(GPIO2_BASE + 0x8010)
#define GPIO2RIS		REGISTER_32(GPIO2_BASE + 0x8014)
#define GPIO2MIS		REGISTER_32(GPIO2_BASE + 0x8018)
#define GPIO2IC			REGISTER_32(GPIO2_BASE + 0x801c)

// Core peripherals

//#define STK_BASE		0xe000e010
//#define SCB_BASE		0xe000ed00
#define NVIC_BASE 		0xe000e000

// NVIC

#define ISER0			REGISTER_32(NVIC_BASE + 0x100)
#define ICER0			REGISTER_32(NVIC_BASE + 0x180)
#define ISPR0			REGISTER_32(NVIC_BASE + 0x200)
#define ICPR0			REGISTER_32(NVIC_BASE + 0x280)
#define IABR0			REGISTER_32(NVIC_BASE + 0x300)
#define IPR0			REGISTER_32(NVIC_BASE + 0x400)
#define IPR1			REGISTER_32(NVIC_BASE + 0x404)
#define IPR2			REGISTER_32(NVIC_BASE + 0x408)
#define IPR3			REGISTER_32(NVIC_BASE + 0x40c)
#define IPR4			REGISTER_32(NVIC_BASE + 0x410)
#define IPR5			REGISTER_32(NVIC_BASE + 0x414)
#define IPR6			REGISTER_32(NVIC_BASE + 0x418)
#define IPR7			REGISTER_32(NVIC_BASE + 0x41c)

// STK

//#define SYST_CSR		REGISTER_32(STK_BASE + 0)
//#define SYST_RVR		REGISTER_32(STK_BASE + 4)
//#define SYST_CVR		REGISTER_32(STK_BASE + 8)
//#define SYST_CALIB		REGISTER_32(STK_BASE + 0x0c)

// SCB_BASE

//#define CPUID			REGISTER_32(SCB_BASE + 0)
//#define ICSR			REGISTER_32(SCB_BASE + 4)
//#define AIRCR			REGISTER_32(SCB_BASE + 0x0c)
//#define SCR			REGISTER_32(SCB_BASE + 0x10)
//#define CCR			REGISTER_32(SCB_BASE + 0x14)
//#define SHPR2			REGISTER_32(SCB_BASE + 0x1c)
//#define SHPR3			REGISTER_32(SCB_BASE + 0x20)

