#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include "lpc11u24.h"
#include "usb.h"
#include <string.h>

extern USBD_HANDLE_T UsbHandle;
extern USB_REPORT *Report;
extern USB_EP_HANDLER_T g_Ep0BaseHdlr;
extern uint8_t tx_busy;
uint8_t data[8];

int main(void)
{
	USBD_API_INIT_PARAM_T usb_param;
	ErrorCode_t ret = LPC_OK;

	// CLK settings

	PDRUNCFG &= ~0x20;					// power-up system osc
	SYSOSCCTRL = 0x00; 					// default
	SYSPLLCLKSEL = 0x01;					// default

	SYSPLLCLKUEN = 0x01;					// toggle
	SYSPLLCLKUEN = 0x00;					// to update
	SYSPLLCLKUEN = 0x01;					// sys pll clock source

	while (!(SYSPLLCLKUEN & 0x01)); 			// wait for update

	SYSPLLCTRL = 0x23;					//
	PDRUNCFG &= ~0x80;					// power-up SYSPLL

	while (!(SYSPLLSTAT & 0x01));	 			// wait for lock

	MAINCLKSEL = 0x03;

	MAINCLKUEN = 0x01;					// toggle
	MAINCLKUEN = 0x00;					// to update
	MAINCLKUEN = 0x01;					// main clock source

	while (!(MAINCLKUEN & 0x01));	 			// wait for update

	SYSAHBCLKCTRL |= 0xC014040;				// bit 6,14,16,26,27

	// USB settings

	PDRUNCFG &= ~0x0580;					// bit 7,8,10
	USBPLLCLKSEL = 0x01;					// USB fed from PLL
	USBPLLCLKUEN = 0x01;					// toggle
	USBPLLCLKUEN = 0x00;					// to update
	USBPLLCLKUEN = 0x01;					// USB clock source

	while (!(USBPLLCLKUEN & 0x01)); 			// wait for update
	USBPLLCTRL = 0x23; 					// ??

	while (!(USBPLLSTAT & 0x01)); 				// wait for lock	

	USBCLKSEL = 0x00;					// USB fed from PLL
	USBCLKDIV = 0x01;

	// I/O

	DIR0 = 0x00000040;
	DIR1 = 0x00000F00;

	PIO0_6 = 1; 
	
	// Debug LEDS

	PIO1_8 = 8;
	PIO1_9 = 8;
	PIO1_10 = 8;
	PIO1_11 = 8;

	// init USB


	memset((void*) &usb_param, 0, sizeof(USBD_API_INIT_PARAM_T));
	UsbdRom_Init(&usb_param);


	/*	WORKAROUND for artf45032 ROM driver BUG:
		Due to a race condition there is the chance that a second NAK event will
		occur before the default endpoint0 handler has completed its preparation
		of the DMA engine for the first NAK event. This can cause certain fields
		in the DMA descriptors to be in an invalid state when the USB controller
		reads them, thereby causing a hang.
	*/

//	pCtrl = (USB_CORE_CTRL_T *) UsbHandle;		/* convert the handle to control structure */
//	g_Ep0BaseHdlr = pCtrl->ep_event_hdlr[0];	/* retrieve the default EP0_OUT handler */
//	pCtrl->ep_event_hdlr[0] = EP0_patch;		/* set our patch routine as EP0_OUT handler */

	ret = usb_hid_init(&usb_param);

	if (ret == LPC_OK) {
		ISER0 = BIT22;
		enable_interrupts();
		USBconnect();
//		tx_busy=0;
while(1);
		while(1) {
			if ((PIN0 & BIT7) == 0) {
//				GPIO1_PBYTE8 = 1;

				// update report based on board state 

				data[0]=0x00;	// modifiers
				data[1]=0x04;	// keycode
//				USBD_API->hw->WriteEP(UsbHandle, 0x81, data, 0x02);
//				tx_busy = 1;
//				while(tx_busy == 1);
				data[0]=0x00;	// modifiers
				data[1]=0x00;	// keycode
				data[2]=0x00;	// keycode
//				GPIO1_PBYTE8 = 0;
//				USBD_API->hw->WriteEP(UsbHandle, 0x81, data, 0x02);
			} else {
//				GPIO1_PBYTE8 = 0;
			}
		}
	}
	return 0;
}
